Subject: Re: [PATCH v2 net] fq_codel: fix NET_XMIT_CN behavior

From: Florian Westphal <[email-masked]>
Date: Mon, 6 Jun 2016 18:18:43 +0200

Eric Dumazet <[email-masked]> wrote:
> On Mon, 2016-06-06 at 13:42 +0200, Florian Westphal wrote:
> > Jamal Hadi Salim <[email-masked]> wrote:
> > > BTW, returning NET_XMIT_CN could be confusing to tcp;
> > > it does not mean that the packet that we are getting return
> > > code for was dropped; it could mean _another_ packet in
> > > the queue was dropped.
> > 
> > Yes, but we currently conceal NET_XMIT_CN from upper layer (tcp)
> > via the net_xmit_* macros:
> > 
> > #define net_xmit_eval(e)       ((e) == NET_XMIT_CN ? 0 : (e))
> > #define net_xmit_errno(e)      ((e) != NET_XMIT_CN ? -ENOBUFS : 0)
> > 
> > Might be worth changing this so tcp reduces cwnd in _CN case too.
> 
> It always had been the case.
> 
> tcp_transmit_skb() calls tcp_enter_cwr(), unless someone broke this.

No, you're right.  We hide error in ip_send_skb but that function is
not used in tcp case.

So all is good here.